=== debian/changelog ===
ncnn (1.0.20221128-deepin1) unstable; urgency=medium

  * Sync to Upstream
  * Fix vulkan module cannot use cmake 3.13 to build
  * Avoid LoongArch connot compile
  * Avoid MIPS64EL compiler SIMD bugs

 -- WangZhengYang <wangzhengyang@uniontech.com>  Tue, 6 Dec 2022 11:21:54 +0800

ncnn (1.0.20220729) unstable; urgency=medium

  * Initial first edition on last release

 -- WangZhengYang <wangzhengyang@uniontech.com>  Mon, 1 Aug 2022 15:21:54 +0800
